---
source_url: https://www.pubnub.com/docs/sdks/php/api-reference/access-manager
title: Access Manager v3 API for PHP SDK
updated_at: 2026-06-19T11:38:04.738Z
sdk_name: PubNub PHP SDK
sdk_version: 9.0.0
---

> Documentation Index
> For a curated overview of PubNub documentation, see: https://www.pubnub.com/docs/llms.txt
> For the full list of all documentation pages, see: https://www.pubnub.com/docs/llms-full.txt


# Access Manager v3 API for PHP SDK

PubNub PHP SDK, use the latest version: 9.0.0

Install:

```bash
composer require pubnub/pubnub@9.0.0
```

:::warning Access Manager isn't enabled by default
Without it, PubNub resources on this keyset have no access controls and clients can reach
channels
and metadata without permission checks. Enable Access Manager in
[Admin Portal](https://admin.pubnub.com/)
before deploying to production.
:::

Access Manager v3 allows you to enforce security controls for client access to resources within the PubNub Platform. With Access Manager v3, your servers (that use a PubNub instance configured with a secret key) can grant their clients tokens with embedded permissions that provide access to individual PubNub resources:

* For a limited period of time.
* Through resource lists or patterns (regular expressions).
* In a single API request, even if permission levels differ (`read` to `channel1` and `write` to `channel2`).

You can add the [authorizedUuid](https://www.pubnub.com/docs/general/security/access-control#authorized-uuid) parameter to the grant request to restrict the token usage to only one client with a given `Uuid`. Once specified, only this `authorizedUuid` will be able to use the token to make API requests for the specified resources, according to permissions given in the grant request.

For more information about Access Manager v3, refer to [Manage Permissions with Access Manager v3](https://www.pubnub.com/docs/general/security/access-control).

## Grant token

:::note Requires Access Manager add-on
This method requires that the *Access Manager* add-on is enabled for your key in the [Admin Portal](https://admin.pubnub.com/). Read the [support page](https://support.pubnub.com/hc/en-us/articles/360051974791-How-do-I-enable-add-on-features-for-my-keys-) on enabling add-on features on your keys.
:::

:::warning Requires Secret Key authentication
Granting permissions to resources should be done by administrators whose SDK instance has been [initialized](https://www.pubnub.com/docs/sdks/php/api-reference/configuration) with a **Secret Key** (available on the [Admin Portal](https://admin.pubnub.com/) on your app's keyset).
:::

The `grantToken()` method generates a time-limited authorization token with an embedded access control list. The token defines time to live (`ttl`), `authorized_uuid`, and a set of permissions giving access to one or more resources:

* `Channels`
* `ChannelGroups`
* `Uuids` (other users' object metadata, such as their names or avatars)

Only this `authorizedUuid` will be able to use the token with the defined permissions. The authorized client will send the token to PubNub with each request until the token's `ttl` expires. Any unauthorized request or a request made with an invalid token will return a `403` with a respective error message.

###### Permissions

The grant request allows your server to securely grant your clients access to the resources within the PubNub Platform. There is a limited set of operations the clients can perform on every resource:

| Resource | Permissions |
| --- | --- |
| `Channels` | `read`, `write`, `get`, `manage`, `update`, `join`, `delete` |
| `ChannelGroups` | `read`, `manage` |
| `Uuids` | `get`, `update`, `delete` |

For permissions and API operations mapping, refer to [Manage Permissions with Access Manager v3](https://www.pubnub.com/docs/general/security/access-control#permissions).

###### TTL (time to live)

The `ttl` (time to live) parameter defines how many minutes the permissions remain valid. After expiration, the client must get a new token to maintain access. `ttl` is required for every grant call. There is no default value. The maximum value is 43,200 (30 days).

For more details, see [TTL in Access Manager v3](https://www.pubnub.com/docs/general/security/access-control#ttl).

###### RegEx patterns

Use regular expressions (RegEx) to specify permissions by pattern instead of listing each resource. Set RegEx permissions as `patterns` before making a grant request. Patterns are evaluated on the server using [RE2-style syntax](https://github.com/google/re2/wiki/Syntax); backreferences and lookaround assertions are not supported.

For more details, see [RegEx in Access Manager v3](https://www.pubnub.com/docs/general/security/access-control#regex).

###### Authorized UUID

Setting an `authorizedUuid` in the token specifies which client should use this token in every request to PubNub. If `authorizedUuid` isn't specified during the grant request, the token can be used by any client with any `Uuid`. Restrict tokens to a single `authorizedUuid` to prevent impersonation.

For more details, see [Authorized UUID in Access Manager v3](https://www.pubnub.com/docs/general/security/access-control#authorized-uuid).

### Method(s)

```php
$pubnub->grantToken()
    ->ttl($ttl)
    ->authorizedUuid($uuid)
    ->addChannelResources(Array[String => String])
    ->addChannelGroupResources(Array[String => String])
    ->addUuidResources(Array[String => String])
    ->addChannelPatterns(Array[String => String])
    ->addChannelGroupPatterns(Array[String => String])
    ->addUuidPatterns(Array[String => String])
    ->meta(Array[String => String])
    ->sync();
```

| Parameter | Description |
| --- | --- |
| `ttl` *Type: `Number`Default: n/a | Total number of minutes for which the token is valid. The minimum allowed value is 1., The maximum is 43,200 minutes (30 days). |
| `authorizedUuid`Type: `String`Default: n/a | Single UUID which is authorized to use the token to make API requests to PubNub. |
| `addChannelResources`Type: `Array`Default: n/a | Array containing explicit channels resource permissions. |
| `addChannelGroupResources`Type: `Array`Default: n/a | Array containing explicit channel groups resource permissions. |
| `addUuidResources`Type: `Array`Default: n/a | Array containing explicit UUID resource permissions. |
| `addChannelPatterns`Type: `Array`Default: n/a | Array containing channels permissions expressed as a RegEx pattern. |
| `addChannelGroupPatterns`Type: `Array`Default: n/a | Array containing channel groups permissions expressed as a RegEx pattern. |
| `addUuidPatterns`Type: `Array`Default: n/a | Array containing UUID permissions expressed as a RegEx pattern. |
| `meta`Type: `Array`Default: n/a | Extra metadata to be published with the request. Values must be scalar only; arrays or objects aren't supported. |

An array for resource/permission should contain the resource name as the key and an array of rights as a value. You don't need to specify the `false` permissions as that's the default value for all rights.

```php
[
    'channel-1' => ['read' => true, 'write' => true]
    'channel-2' => ['read' => true, 'write' => false]
    'channel-3' => ['read' => true]
]
```

:::note Required key/value mappings
For a successful grant request, you must specify permissions for at least one `Uuid`, `Channel`, or `ChannelGroup`, either as a resource list or as a pattern (RegEx).
:::

### Sample code

:::tip Reference code
This example is a self-contained code snippet ready to be run. It includes necessary imports and executes methods with console logging. Use it as a reference when working with other examples in this document.
:::

```php
try {
    $token = $admin->grantToken()
        ->ttl(60) // 60 minutes
        ->authorizedUuid('regular-user') // Restrict to specific user
        ->addChannelResources([
            $publicChannel => ['read' => true, 'write' => true], // Full access
            $readOnlyChannel => ['read' => true], // Read only - no write
            $privateChannel => ['read' => true, 'write' => true, 'manage' => true] // Full access including manage
        ])
        ->addChannelGroupResources([
            $userGroup => ['read' => true] // Read only for channel groups
        ])
        ->addUuidResources([
            'regular-user' => ['get' => true, 'update' => true], // Self metadata access
            'other-user' => ['get' => true] // Read-only access to other user's metadata
        ])
        ->meta([
            'purpose' => 'demo-token',
            'issued-by' => 'admin-user'
        ])
        ->sync();

    printResult("Grant comprehensive token", true);
    echo "Generated token: " . substr($token, 0, 50) . "...\n\n";
} catch (Exception $e) {
    printResult("Grant comprehensive token", false, $e->getMessage());
    echo "⚠️  Cannot continue without token. Exiting.\n";
    exit(1);
}
```

### Returns

```json
"p0thisAkFl043rhDdHRsCkNyZXisRGNoYW6hanNlY3JldAFDZ3Jwsample3KgQ3NwY6BDcGF0pERjaGFuoENnctokenVzcqBDc3BjoERtZXRhoENzaWdYIGOAeTyWGJI"
```

### Other examples

#### Grant an authorized client different levels of access to various resources in a single call

The code below grants `my-authorized-uuid`:

* Read access to `channel-a`, `channel-group-b`, and get to `uuid-c`.
* Read/write access to `channel-b`, `channel-c`, `channel-d`, and get/update to `uuid-d`.

```php
$pubnub->grantToken()
    ->ttl(15)
    ->authorizedUuid('my-authorized-uuid')
    ->addChannelResources([
        'channel-a' => ['read' => true],
        'channel-b' => ['read' => true, 'write' => true],
        'channel-c' => ['read' => true, 'write' => true],
        'channel-d' => ['read' => true, 'write' => true],
    ])
    ->addChannelGroupResources([
        'channel-group-b' => ['read' => true],
    ])
    ->addUuidResources([
        'uuid-c' => ['get' => true],
        'uuid-d' => ['get' => true, 'update' => true],
    ])
    ->sync();
```

#### Grant an authorized client read access to multiple channels using RegEx

The code below grants `my-authorized-uuid` read access to all channels that match the `channel-[A-Za-z0-9]` RegEx pattern.

```php
$pubnub->grantToken()
    ->ttl(15)
    ->authorizedUuid('my-authorized-uuid')
    ->addChannelPatterns([
        '^channel-[A-Za-z0-9]$' => ['read' => true],
    ])
    ->sync();
```

#### Grant an authorized client different levels of access to various resources and read access to channels using RegEx in a single call

The code below grants the `my-authorized-uuid`:

* Read access to `channel-a`, `channel-group-b`, and get to `uuid-c`.
* Read/write access to `channel-b`, `channel-c`, `channel-d`, and get/update to `uuid-d`.
* Read access to all channels that match the `channel-[A-Za-z0-9]` RegEx pattern.

```php
$pubnub->grantToken()
    ->ttl(15)
    ->authorizedUuid('my-authorized-uuid')
    ->addChannelResources([
        'channel-a' => ['read' => true],
        'channel-b' => ['read' => true, 'write' => true],
        'channel-c' => ['read' => true, 'write' => true],
        'channel-d' => ['read' => true, 'write' => true],
    ])
    ->addChannelGroupResources([
        'channel-group-b' => ['read' => true],
    ])
    ->addUuidResources([
        'uuid-c' => ['get' => true],
        'uuid-d' => ['get' => true, 'update' => true],
    ])
    ->addChannelPatterns([
        '^channel-[A-Za-z0-9]$' => ['read' => true],
    ]);
```

### Error responses

If you submit an invalid request, the server returns HTTP 400 with a message that identifies the missing or incorrect argument. Causes can include a RegEx issue, an [invalid timestamp](https://support.pubnub.com/hc/en-us/articles/360051973331-Why-do-I-get-Invalid-Timestamp-when-I-try-to-grant-permission-using-Access-Manager-), or incorrect permissions. The server returns the error details in `PubNubServerException`.

| Method | Description |
| --- | --- |
| `getStatusCode()`Type: `Int` | Status code `400` that is returned by the server by default. |
| `getBody()`Type: `Object` | Entire body of the error returned by the server. The body contains such fields as `message`, `source`, `details`, `service`, and `status`. |
| `getServerErrorMessage()`Type: `String` | Descriptive error message, such as `Invalid ttl`. |
| `getServerErrorSource()`Type: `String` | Source of the error. |
| `getServerErrorDetails()`Type: `Object` | Details of the first encountered problem. This object contains these public properties: `message`, `location`, and `locationType`. |

## Revoke token

:::note Requires Access Manager add-on
This method requires that the *Access Manager* add-on is enabled for your key in the [Admin Portal](https://admin.pubnub.com/). Read the [support page](https://support.pubnub.com/hc/en-us/articles/360051974791-How-do-I-enable-add-on-features-for-my-keys-) on enabling add-on features on your keys.
:::

:::note Enable token revoke
To revoke tokens, you must first enable this feature on the [Admin Portal](https://admin.pubnub.com/). To do that, navigate to your app's keyset and mark the *Revoke v3 Token* checkbox in the *ACCESS MANAGER* section.
:::

The `revokeToken()` method allows you to disable an existing token and revoke all permissions embedded within. You can only revoke a valid token previously obtained using the `grantToken()` method.

Use this method for tokens with `ttl` less than or equal to 30 days. If you need to revoke a token with a longer `ttl`, [contact support](https://www.pubnub.com/docs/mailto:support@pubnub.com).

For more information, refer to [Revoke permissions](https://www.pubnub.com/docs/general/security/access-control#revoke-permissions).

### Method(s)

```php
$pubnub->revokeToken($token)
    ->sync();
```

| Parameter | Description |
| --- | --- |
| `token` *Type: `String`Default: n/a | Existing token with embedded permissions. |

### Sample code

```php
try {
    $admin->setToken($token);
    print("Revoking token {{$token}}...\n");
    $revokeResult = $admin->revokeToken()->token($token)->sync();
    print_r($revokeResult);
    $admin->setToken('');
    printResult("Admin revoke token", true);
    // token revoke propagation might take some time
    $attempts = 0;
    $waitForRevoke = getenv('WAIT_FOR_REVOKE') ?? true;
    while ($waitForRevoke) {
        $attempts++;
        print("Attempt: $attempts\n");
        if ($attempts > 10) {
            printResult("User publish after token revocation", false, "Should have failed but succeeded");
            break;
        }
        sleep(10);
        // Test user access after revocation (should fail)
        try {
            $publishResult = $user->publish()
                ->channel($publicChannel)
                ->message(['text' => 'Hello after revocation!'])
                ->sync();
            // print_r($publishResult);
            // printResult("User publish after token revocation", false, "Should have failed but succeeded");
        } catch (Exception $e) {
            printResult("User publish after token revocation", true, "Correctly denied - token revoked");
            break;
        }
    }
} catch (Exception $e) {
    printResult("Admin revoke token", false, $e->getMessage());
}
```

### Returns

When the token revocation request is successful, this method returns a `PNRequestResult`. When the request fails, it returns `PubNubServerException`.

#### PNRequestResult

| Method | Description |
| --- | --- |
| `getStatus()`Type: `Int` | Server response status `200`. |
| `getService()`Type: `String` | Service to which the request was made. In this case, `Access Manager`. |
| `isError()`Type: `Boolean` | Whether the response is an error message. |
| `getError()`Type: `Array` | Error returned by the server. |
| `getMessage()`Type: `String` | Message returned by the server on successful request. In this case, `Success`. |

### Error Responses

If you submit an invalid request, the server returns an error status code with a descriptive message informing which of the provided arguments is missing or incorrect. Depending on the root cause, this operation may return the following errors:

* `400 Bad Request`
* `403 Forbidden`
* `503 Service Unavailable`

## Parse token

The `parseToken()` method decodes an existing token and returns the object containing permissions embedded in that token. The client can use this method for debugging to check the permissions to the resources or find out the token's `ttl` details.

### Method(s)

```php
parseToken(String token)
```

| Parameter | Description |
| --- | --- |
| `token` *Type: `String`Default: n/a | Current token with embedded permissions. |

### Sample code

```php
try {
    $parsedToken = $admin->parseToken($token);
    printResult("Parse token", true);

    echo "Token Details:\n";
    echo "- Version: " . $parsedToken->getVersion() . "\n";
    echo "- TTL: " . $parsedToken->getTtl() . " minutes\n";
    echo "- Authorized UUID: " . ($parsedToken->getUuid() ?? 'None') . "\n";
    echo "- Timestamp: " . date('Y-m-d H:i:s', $parsedToken->getTimestamp()) . "\n";

    // Show channel permissions
    echo "\nChannel Permissions:\n";
    foreach ([$publicChannel, $readOnlyChannel, $privateChannel] as $channel) {
        $permissions = $parsedToken->getChannelResource($channel);
        if ($permissions) {
            echo "- $channel: ";
            $perms = [];
            if ($permissions->hasRead()) {
                $perms[] = 'read';
            }
            if ($permissions->hasWrite()) {
                $perms[] = 'write';
            }
            if ($permissions->hasManage()) {
                $perms[] = 'manage';
            }
            echo implode(', ', $perms) ?: 'none';
            echo "\n";
        }
    }

    // Show metadata
    $metadata = $parsedToken->getMetadata();
    if ($metadata) {
        echo "\nToken Metadata:\n";
        foreach ($metadata as $key => $value) {
            echo "- $key: $value\n";
        }
    }
} catch (Exception $e) {
    printResult("Parse token", false, $e->getMessage());
}
```

### Returns

```php
$parsedToken = $pubnub->parseToken( "p0thisAkFl043rhDdHRsCkNyZXisRGNoYW6hanNlY3JldAFDZ3Jwsample3KgQ3NwY6BDcGF0pERjaGFuoENnctokenVzcqBDc3BjoERtZXRhoENzaWdYIGOAeTyWGJI")
->toArray();

array(7) {
  ["version"]=>
  int(2)
  ["timestamp"]=>
  int(1634592012)
  ["ttl"]=>
  int(15)
  ["resources"]=>
  array(1) {
    ["chan"]=>
    array(1) {
      ["my-channel"]=>
      array(8) {
        ["read"]=>
        bool(true)
        ["write"]=>
        bool(false)
        ["manage"]=>
        bool(false)
        ["delete"]=>
        bool(false)
        ["create"]=>
        bool(false)
        ["get"]=>
        bool(false)
        ["update"]=>
        bool(false)
        ["join"]=>
        bool(false)
      }
    }
  }
  ["patterns"]=>
  array(0) {
  }
  ["signature"]=>
  string(44) "IBrbsLkRUqxZkN0ZPw8-bV2KxzB1Py-vJ-CaynRUn4Q="
  ["uuid"]=>
  string(7) "my-uuid"
}
```

| Method | Parameter | Return type | Description |
| --- | --- | --- | --- |
| `getVersion()` | none | `Int` | Token version. The current version is `2`. |
| `getTimestamp()` | none | `Int` | Timestamp of the issued token. |
| `getTtl()` | none | `String` | Total number of minutes for which the token is valid. |
| `getResources()` | none | `Array` | List of all resources included in the token in the following format: `type => name => permissions` |
| `getPatterns()` | none | `Array` | List of all patterns included in the token in the following format: `type => name => permissions` |
| `getChannelResource($channel)` | `String` | `Object` | Instance of the `Permissions` object for a specific channel. It returns `null` if no permissions are defined. |
| `getChannelGroupResource($channelGroup)` | `String` | `Object` | Instance of the `Permissions` object for a specific channel group. It returns `null` if no permissions are defined. |
| `getUuidResource($uuid)` | `String` | `Object` | Instance of the `Permissions` object for a specific UUID. It returns `null` if no permissions are defined. |
| `getChannelPattern($channel)` | `String` | `Object` | Instance of the `Permissions` object for a specific channel. It returns `null` if no permissions are defined. |
| `getChannelGroupPattern($channelGroup)` | `String` | `Object` | Instance of the `Permissions` object for a specific channel group. It returns `null` if no permissions are defined. |
| `getUuidPattern($uuid)` | `String` | `Object` | Instance of the `Permissions` object for a specific UUID. It returns `null` if no permissions are defined. |
| `getMetadata()` | none | `Array` | Array of metadata set in the grant token request. |
| `getSignature()` | none | `String` | Signature generated by the server. |
| `getUuid()` | none | `String` | Authorized UUID |
| `toArray()` | none | `Array` | Entire token in an array format |

#### Permissions object

Calling `getChannelResource()` returns an instance of the `Permissions` object. This object has a series of methods to access specific rights.

```php
$pubnub->parseToken("p0F2AkF0Gl2BEIJDdHRsGGRDcmVzpERjaGFuoENncnCgQ3VzcqBDc3BjoENwYXSkRGNoYW6gQ2dycKBDdXNyomZeZW1wLSoDZl5tZ3ItKhgbQ3NwY6JpXnB1YmxpYy0qA2pecHJpdmF0ZS0qGBtEbWV0YaBDc2lnWCAsvzGmd2rcgtr9rcs4r2tqC87YSppSYqs9CKfaM5IRZA")
    ->getChannelResource('my-channel');
```

| Method | Return type | Description |
| --- | --- | --- |
| `hasRead()` | `boolean` | `read` rights that apply to Subscribe, History, and Presence. |
| `hasWrite()` | `boolean` | `write` rights that apply to Publish. |
| `hasManage()` | `boolean` | `manage` rights that apply to channel groups and App Context. |
| `hasDelete()` | `boolean` | `delete` rights that apply to History and App Context. |
| `hasGet()` | `boolean` | `get` rights that apply to App Context (formerly Objects v2). |
| `hasUpdate()` | `boolean` | `update` rights that apply to App Context (formerly Objects v2). |
| `hasJoin()` | `boolean` | `join` rights that apply to App Context (formerly Objects v2). |

For example, calling `hasRead()` returns `true`.

### Error Responses

If you receive an error while parsing the token, it may suggest that the token is damaged. In that case, request the server to issue a new one.

## Set token

The `setToken()` method is used by the client devices to update the authentication token granted by the server.

### Method(s)

```php
setToken(String token)
```

| Parameter | Description |
| --- | --- |
| `token` *Type: `String`Default: n/a | Current token with embedded permissions. |

### Sample code

```php
// Set the token for the user
$user->setToken($token);
echo "Token set for user.\n";

// Test allowed operations
try {
    $result = $user->publish()
        ->channel($publicChannel)
        ->message(['text' => 'Hello with token!', 'timestamp' => time()])
        ->sync();
    printResult("User publish to public-channel WITH token", true, "Message published successfully");
} catch (Exception $e) {
    printResult("User publish to public-channel WITH token", false, $e->getMessage());
}

try {
    $result = $user->history()
        ->channel($publicChannel)
        ->count(5)
        ->sync();
    printResult("User read from public-channel WITH token", true, "History retrieved successfully");
} catch (Exception $e) {
    printResult("User read from public-channel WITH token", false, $e->getMessage());
}

try {
    $result = $user->history()
        ->channel($privateChannel)
        ->count(5)
        ->sync();
    printResult("User read from private-channel WITH token", true, "History retrieved successfully");
} catch (Exception $e) {
    printResult("User read from private-channel WITH token", false, $e->getMessage());
}
```

### Returns

This method doesn't return any response value.

## Terms in this document

* **Access Manager** - A cryptographic, token-based permission administrator that allows you to regulate clients' access to PubNub resources, such as channels, channel groups, and user IDs.
* **Action** - The type of activity (procedure) to execute when a condition is satisfied (for example, sending a message).
* **Billing alert notification** - A means of informing a user that a billing alert has been triggered. Before notifications can happen, a billing alert must be triggered first.
* **Business Object** - A container for data fields and metrics that defines aggregations and data sources.
* **Channel** - A pathway for sending and receiving messages between devices, created automatically when you first use it, that can handle any number of users and messages for different communication needs, like 1-1 text chats, group conversations, and other data streaming.
* **Channel pattern** - A way to group and analyze channel data to track performance metrics like message counts and user engagement over time with PubNub Insights.
* **Condition** - A requirement that must be satisfied or evaluated to true for an action to be executed. Input in a decision table.
* **Cryptor** - An implementation of a specific cryptographic algorithm used for data encryption/decryption that adheres to a standard interface.
* **Dashboard** - A collection of widgets (charts) that give an overview of the metrics one is evaluating.
* **Data fields** - Data you want Illuminate to track. These can be quantitative (measures), like "Number" or "Timestamp" or qualitative (dimensions) values, like "String" that can be used to categorize and segment data. Data fields can be aggregated and calculated.
* **Decision** - A collection (or decision table) of conditions and actions. When conditions are satisfied, the corresponding actions are triggered as per defined rules.
* **End Customer** - A customer of a PubNub partner. End customers do not have direct access to the Admin Portal. Instead, they interact with PubNub products—such as Illuminate—through the partner’s portal, where PubNub services are embedded. They can create PubNub objects only within this partner-provided environment.
* **Entity** - A subscribable object within a PubNub SDK that allows you to perform context-specific operations.
* **Listener** - A function or objectthat reacts to events or messages, like new chat messages or connection updates, letting your app respond in real-time.
* **Mapped/Unmapped** - Whether the data source for a data field has been defined or the action has been configured.
* **MCP Server** - A Model Context Protocol server that coordinates communication and synchronization between AI agents, clients, or services, such as Cursor IDE and Windsurf.
* **Message** - A unit of data transmitted between clients or between a client and a server in PubNub, containing information such as text, binary data, or structured data formats like JSON. Messages are sent over channels and can be tracked for delivery and read status.
* **Metric** - What exactly is evaluated using measures and dimensions (collectively called data fields), as well as aggregation functions.
* **Module** - A Functions v1 container that groups related functions for configuration and deployment on an app’s keysets.
* **Origin** - The subdomain used to establish a connection to the PubNub network that allows your application's traffic to appear like it's coming from your own domain.
* **Package** - A Functions v2 container that groups Functions, tracks Revisions, and is deployed to keysets.
* **Partner** - A PubNub customer who resells PubNub products, such as Illuminate, to their own customers. Partners have access to the Admin Portal, enabling them to create and manage PubNub objects for themselves or on behalf of their end customers.
* **Publish Key** - A unique identifier that allows your application to send messages to PubNub channels. It's part of your app's credentials and should be kept secure.
* **PubNub** - PubNub is a real-time messaging platform that provides APIs and SDKs for building scalable applications. It handles the complex infrastructure of real-time communication, including: Message delivery and persistence, Presence detection, Access control, Push notifications, File sharing, Serverless processing with Functions and Events & Actions, Analytics and monitoring with BizOps Workspace, AI-powered insights with Illuminate.
* **Push token** - A device identifier issued by a push provider (APNs or FCM) used to register a device for receiving mobile push notifications.
* **Rule** - A definition (row in a decision table) stating which action should be triggered for which condition.
* **Service Integration** - A machine identity that represents a program or service consuming the Admin API, scoped to your account and authenticated using expirable API keys with configurable permissions.
* **Signal** - A non-persistent message limited to 64 bytes designed for high-volume usecases where the the most recent data is relevant, like GPS location updates.
* **Subscribe Key** - A unique identifier that allows your application to receive messages from PubNub channels. It's part of your app's credentials and should be kept secure.
* **Timetoken** - A unique identifier for each message that represents the number of 100-nanosecond intervals since January 1, 1970, for example, 16200000000000000.
* **Trigger details** - A set of predefined criteria for a given billing alert. When met, billing alert notifications are generated.
* **User** - An individual or entity that interacts with a system, application, or service. In PubNub, a user typically refers to someone who sends or receives messages through the platform, identified by a unique user ID or username.
* **User ID** - UTF-8 encoded, unique string of up to 92 characters used to identify a single client (end user, device, or server) that connects to PubNub.
* **Vibe Coding** - A way to build applications in an intuitive, relaxed, and improvisational manner, using AI tools and natural language descriptions.